#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_DropCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_DropCFG> M_DropCFG::msSingleton(nullptr);

int M_DropCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_DropCFGData* M_DropCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_DropCFGData>& M_DropCFG::GetMapData()
{
	return mMapData;
}

void M_DropCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_DropCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_DropCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		{
			const char* dropInfo = element->Attribute("dropInfo");
			std::vector<std::string> vecdropInfo;
			boost::split(vecdropInfo, dropInfo, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecdropInfo.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecdropInfo[i].c_str(), &temp))
				{
					data.mdropInfo.push_back(temp);
				}
			}
		}
		data.mstarRate = element->IntAttribute("starRate");
		data.mEndRate = element->IntAttribute("EndRate");
		{
			const char* DropCount = element->Attribute("DropCount");
			std::vector<std::string> vecDropCount;
			boost::split(vecDropCount, DropCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDropCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDropCount[i].c_str(), &temp))
				{
					data.mDropCount.push_back(temp);
				}
			}
		}
		data.mOtherTypes = element->IntAttribute("OtherTypes");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_DropCFG::Load()
{
	Load("../Config/M_DropCFG.xml");
}

M_DropCFG* M_DropCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_DropCFG());
	}
	return msSingleton.get();
}
